from abc import ABC, abstractmethod
from typing import Dict

model_pathMap = {}

def collection_delete_register(model_key, Klass):
    """Register a model class for a given model key."""
    global model_pathMap
    model_pathMap[model_key] = Klass

def get_collection_delete_class(model_path):
    """Find the model class for a given model path."""
    for k, klass in model_pathMap.items():
        if len(model_path.split(k)) > 1:
            return klass
    print(f'{model_pathMap=}')
    return None

class BaseCollectionDelete(ABC):
    @abstractmethod
    def delete_collection(self, db_type: str) -> Dict:
        """Delete a Milvus collection for the given db_type."""
        pass